;(clear-all)

(define-model 
  pyramids

  (sgp :esc t :bll 0.5 :rt -1.6 :ol 4 :ans nil :er t :TRACE-DETAIL low  :MODEL-WARNINGS nil)  


  (sgp :save-buffer-trace t :traced-buffers (production goal imaginal visual retrieval manual) :bold-inc 2 :bold-exp 5 :bold-scale 1 :neg-bold-exp 15 :neg-bold-scale 1 :bold-positive 6 :bold-negative 1)
  (sgp :mp 7);
  (sgp :lf .25);
  (sgp :md -1)


  (set-visloc-default isa visual-location screen-x lowest screen-y lowest :attended new)
  (start-hand-at-mouse)



  (chunk-type add-pair one1 ten1 one2 ten2 one-ans ten-ans combined-sum carry scratch scratch2 scratch3)
  (chunk-type operator pre action arg1 arg2 next-state alt)
  (chunk-type pyramid base height value current-term unknown-field current-problem current-problem-position scratch)
  
  (chunk-type task state step next-state role  value current-term 
              current-problem current-problem-position) 
  
  (chunk-type addition-fact addend1 addend2 sum)
  (chunk-type equation-token string)
  (chunk-type problem-position)
  (chunk-type item-location item location)
   (chunk-type feedback base height value status)
  (chunk-type stored-solution)

  (add-numbers-to-dm)
  (set-number-similarities)
  (initialize-position-chunks 0)
  (add-dm 
    (goal isa task state nil step nil next-state nil role nil value nil current-problem 0 current-problem-position P1)
    
    (x isa equation-token string "x")
    (dollar-sign isa equation-token string "$")
    (equal-sign isa equation-token string "=")
    (plus-sign isa equation-token string "+")

    (base-position isa visual-location screen-x  75   screen-y  60)
    (height-position isa visual-location screen-x  125   screen-y  60)
    (value-position isa visual-location screen-x  175   screen-y  60)

    (base-il isa item-location item base location base-position)
    (height-il isa item-location item height location height-position)
    (value-il isa item-location item value location value-position)

    ; check these in the visicon if placement or platform changes (they refer to the
    ; centers)


    )

  ; for all non-math chunks
  (set-all-base-levels 1000 -1000)

  (add-weighted-addition-facts 1) ; wf
  
  (p lookup-base-loc
     =goal>
      isa task
      state encode-base
      step ready
      current-problem =prob
    ?imaginal>
      state free
    ?retrieval>
      state free
      buffer empty
  ==>
    +retrieval>
      isa item-location
      item base
    +imaginal>
      isa pyramid
      current-problem =prob
  )


  (p look-for-base
    =goal>
        isa task
        state encode-base
        step ready
    =retrieval>
      isa item-location
      item base
      location =loc
  ==>
    +goal>
        role base
        step looking
        next-state encode-height
    +visual-location>
        isa visual-location
        :nearest =loc
  )
  
  (p lookup-height-loc
     =goal>
      isa task
      state encode-height
      step ready
    ?retrieval>
      state free
      buffer empty
  ==>
    +retrieval>
      isa item-location
      item height
  )

  (p look-for-height
    =goal>
        isa task
        state encode-height
        step ready
    =retrieval>
      isa item-location
      item height
      location =loc
  ==>
    +goal>
        role height
        step looking
        next-state encode-value
    +visual-location>
        isa visual-location
        :nearest =loc
  )

  (p lookup-value-loc
     =goal>
      isa task
      state encode-value
      step ready
    ?retrieval>
      state free
      buffer empty
  ==>
    +retrieval>
      isa item-location
      item value
  )


  (p look-for-value
    =goal>
        isa task
        state encode-value
        step ready
    =retrieval>
      isa item-location
      item value
      location =loc
  ==>
    +goal>
        role value
        step looking
        next-state begin-solving
    +visual-location>
        isa visual-location
        :nearest =loc
  )

  (p look
    =goal>
      isa task
      step looking
    =visual-location>
      isa visual-location
    =imaginal>
      isa pyramid
  ?manual>
    state free
    ==>
    +visual>
      isa move-attention
      screen-pos =visual-location
    +goal>
      step attending
    =imaginal> =imaginal

  )
 
 (p* lookup-token
   =goal>
     isa task
     next-state =post
     step attending
     role =role
   =visual>
     isa text
     value =val
     - value "x"
  =imaginal>
    isa pyramid
  ?imaginal>
       state free
   ==>
   !safe-bind! =num (string-to-chunk =val)
  +retrieval>
    isa equation-token
    string =val
   +goal>
     step dereferencing-number
  =imaginal> =imaginal
 )
 
 (p* lookup-token-unknown
   =goal>
     isa task
     next-state =post
     step attending
     role =role
   =visual>
     isa text
     value "x"
  =imaginal>
     isa pyramid
  ?imaginal>
       state free
  ==>
  +retrieval>
    isa equation-token
    string "x"
   +goal>
     step dereferencing-x
  =imaginal> =imaginal
 )


 (p* collect-result-number
   =goal>
     isa task
     next-state =post
     step dereferencing-number
     role =role
   =retrieval>
     isa equation-token
   =imaginal>
     isa pyramid
  ?imaginal>
    state free
   ==>
   +goal>
     step ready
     state =post
     next-state nil
   +imaginal>
      =role =retrieval
 )

(p collect-result-unknown
  =goal>
    isa task
    next-state =post
    step dereferencing-x
    role =role
  =retrieval>
    isa equation-token
  =imaginal>
    isa pyramid
  ?imaginal>
    state free
==>
  +goal>
    step ready
    state =post
    next-state nil
  +imaginal>
    unknown-field =role
 )
 
 (p start-add-up
  =goal>
    isa task
    state add-up
  =imaginal>
    isa pyramid
    base =base
  ?imaginal>
       state free
  ==>
  !safe-bind! =baseOnes (ones =base)
  !safe-bind! =baseTens (tens =base)
  !safe-bind! =nextOnes (ones (decrement =base))
  !safe-bind! =nextTens (tens (decrement =base))
  +imaginal>
    isa add-pair
    one1 =baseOnes
    ten1 =baseTens
    one2 =nextOnes
    ten2 =nextTens
  +goal>
    step start-add
  )

 (p next-add-up
   =goal>
     isa task
     state add-up
     step add-done
     value =val
   =imaginal>
     isa add-pair
     combined-sum =sum
     one2 =ones
     ten2 =tens
     one-ans =oa
     ten-ans =ta
  ?imaginal>
       state free
   !safe-bind! =last-term (combine =tens =ones)
   !safe-eval! (not (eq =last-term =val))
   ==>
   !safe-bind! =next-term (decrement =last-term)
   !safe-bind! =next-ones (ones =next-term)
   !safe-bind! =next-tens (tens =next-term)
   +imaginal>
     one-ans nil
     ten-ans nil
     combined-sum nil
     one1 =oa
     ten1 =ta
     one2 =next-ones
     ten2 =next-tens
  +goal>
    step start-add
 )
 
 (p add-up-done
   =goal>
     isa task
     state add-up
     step add-done
     value =val
   =imaginal>
     isa add-pair
     combined-sum =sum
     one2 =ones
     ten2 =tens
     one-ans =oa
     ten-ans =ta
   !safe-bind! =last-term (combine =tens =ones)
   !safe-eval! (eq =last-term =val)
  ==>
  +goal>
    state answer
    step start
    value =sum
  )
 
 (p begin-solving-uv-inplace
  =goal>
    isa task
    state begin-solving
  =imaginal>
    isa pyramid
    unknown-field value
    height =height
    base =base
  ?imaginal>
       state free
  ==>
  !safe-bind! =baseOnes (ones =base)
  !safe-bind! =baseTens (tens =base)
  !safe-bind! =nextOnes (ones (decrement =base))
  !safe-bind! =nextTens (tens (decrement =base))
  !safe-bind! =rtd (decrement =height)
  +imaginal>
    isa add-pair
    one1 =baseOnes
    ten1 =baseTens
    one2 =nextOnes
    ten2 =nextTens
    scratch =rtd ; decrement each rep, stop when =0
  +goal>
    state uv-in-place
    step start-add
  +retrieval>
    isa stored-solution
  )

 (p next-inplace-add-up
   =goal>
     isa task
     state uv-in-place
     step add-done
   =imaginal>
     isa add-pair
     combined-sum =sum
     one2 =ones
     ten2 =tens
     one-ans =oa
     ten-ans =ta
     scratch =rtd
  ?imaginal>
       state free
   !safe-eval! (not (eq =rtd 'n1))
   ==>
   !safe-bind! =last-term (combine =tens =ones)
   !safe-bind! =next-term (decrement =last-term)
   !safe-bind! =next-ones (ones =next-term)
   !safe-bind! =next-tens (tens =next-term)
   !safe-bind! =new-rtd (decrement =rtd)
   +imaginal>
     one-ans nil
     ten-ans nil
     combined-sum nil
     one1 =oa
     ten1 =ta
     one2 =next-ones
     ten2 =next-tens
     scratch =new-rtd
  +goal>
    step start-add
 )
 
 (p uv-inplace-done
   =goal>
     isa task
     state uv-in-place
     step add-done
   =imaginal>
     isa add-pair
     combined-sum =sum
     one2 =ones
     ten2 =tens
     one-ans =oa
     ten-ans =ta
     scratch n1 ; last rep done
  ==>
  !safe-eval! (print (format nil "Answering ~A."  =sum))
  +goal>
    state answer
    step start
    value =sum
  )
 
 (p respond
     =goal>
       isa task
       state answer
       step start
       value =val
   ==>
   !safe-bind! =stringval (chunk-to-string =val)
     +goal>
       step respond ; press-keys
       value =stringval
   )

 (p key-next-digit
    =goal>
      isa task
      step respond
      value =val
    ?manual>
      state free
    !safe-eval! (not (equal =val "")) 
  ==>
    !safe-bind! =rest (subseq =val 1 (length =val))
    !safe-bind! =key  (string (aref =val 0))
    +manual>
       ISA         press-key
       key         =key
    +goal>
      value =rest
      step attend-entered
  )

 (p key-enter
    =goal>
      isa task
      step respond
      value ""
    ?manual>
      state free

  ==>
    +manual>
       ISA         press-key
       key         "R"
    +goal>
      step ready
      state done
  )
  
 (p attend-entered
   =goal>
    isa task
    step attend-entered
  =visual-location>
    isa visual-location
    color black
  ?visual>
    state free
  ?manual>
    state free
 ==>
   +visual>
     isa move-attention
     screen-pos =visual-location
  +goal>
    step respond
 )

   
   (p done
     =goal>
       isa task
       state done
   ==>
     +goal>
       step find-feedback ;attend-feedback
       state read-base
     +visual>
      isa clear
    +retrieval>
       isa pyramid
    +imaginal>
       isa feedback

   )

 (p find-feedback
  =goal>
    isa task
    step find-feedback
  =visual> 
    isa text
  =imaginal>
     isa feedback
  ?visual-location>
    state free
  ?visual>
    state free
  ==>
    =imaginal>
       value =visual
    +visual-location>
      isa visual-location
      screen-y current
      screen-x lowest
      > screen-x current
  )
 

 
 (p find-feedback-next-line
  =goal>
    isa task
    step find-feedback
  ?visual-location>
   state error
  ==>
    +visual-location>
      isa visual-location
      screen-y lowest
      screen-x lowest
      > screen-y current
   +goal>
     step attend-feedback-nl ; can't stay attend-feedback or it will loop on error
  )


 (p attend-feedback
    =goal>
     isa task
     step find-feedback
   =visual-location>
     isa visual-location
     color green
   ?visual>
     state free
  ?manual>
    state free
 ==>
   +visual>
     isa move-attention
     screen-pos =visual-location
   ;+manual>
   ;  isa move-cursor
   ;  loc =visual-location
 )
 
(p incorporate-problem
    =imaginal>
       isa feedback
       base nil
       height nil
    =retrieval>
       isa pyramid
       base =n1
       height =n2
       value nil
==>
    =imaginal>
       base =n1
       height =n2)

 (p attend-feedback-nl
    =goal>
     isa task
     step attend-feedback-nl
   =visual-location>
     isa visual-location
   ?visual>
     state free
  ?manual>
    state freek
 ==>
   +visual>
     isa move-attention
     screen-pos =visual-location
  ;+manual>
  ;  isa move-cursor
  ;  loc =visual-location
  +goal>
    step find-feedback
 )

 (p feedback-done
    =goal>
     isa task
     step attend-feedback-nl
   ?visual-location>
     state error
   ?visual>
     state free
    =imaginal>
       isa feedback
 ==>
  +imaginal>
      status success
  +retrieval>
      isa pyramid
  +goal>
    step feedback-done
)

(p incorporate-answer
    =imaginal>
       isa feedback
       status success
       value =value
     =retrieval>
       isa pyramid
       value nil
 ==>
  =retrieval>
      value =value)
   

 (p find-rd
    =goal>
    isa task
    step feedback-done
    =visual-location>
      isa visual-location
      kind text
    ==>
    +visual-location>
      isa visual-location
      kind oval
)

 (p attend-rd
    =goal>
     isa task
     step feedback-done
   =visual-location>
     isa visual-location
     kind oval
   ?visual>
     state free
  ?manual>
    state free
 ==>
    +goal>
      step repetition-detection
    +visual-location>
      isa visual-location
      kind text
      screen-y 110
    +manual>
      isa prepare
      style punch
      hand right
      finger index
    )

  (p attend-rd-text
    =goal>
      isa task
      step repetition-detection
    =visual-location>
      isa visual-location
      kind text
    ?visual> 
      state free
      ==>
    +visual>
      isa move-attention
      screen-pos =visual-location
    +goal>
      step attending-rd
  )

  (p attending-rd-click
    =goal>
      isa task
      step attending-rd
    ?visual-location>
     state free
    =visual>
      isa text
    ?manual>
      state free
      !safe-eval! (> *nback-match* 0)
  ==>
    +manual>
       ISA         press-key
       key         "C"
    +visual>
      isa clear
  )

  (p attending-rd-noclick
    =goal>
      isa task
      step attending-rd
    ?visual-location>
     state free
    =visual>
      isa text
    ?manual>
      state free
      !safe-eval! (eq *nback-match* 0)
  ==> ; harvest only
    +visual>
      isa clear
  )


 ; ; addition productions adapted from tutorial model
   ; subtraction capability included, in that case the second number should be
   ; negated (both digits)
   ;
   ; assuming the following are done in rule conditions, rather than through
   ; fact retrieval:
   ;
   ; dividing out and recombining the ones and tens places
   ; checking if a number is > 10
   ; checking if a number is < 0
   ; adding 10 to a number 0-9 (unless that is the overall problem)
   ; subtracting 10 from 10-19 (similarly)
   ;
   ; interface: build an imaginal chunk for the addition problem
   ; set iteration to be the current iteration chunk (which will be restored to
   ; the buffer when done), set role to be the slot name in the iteration chunk
   ; where the result should be placed, and next-step to be the goal step to set
   ; when its all done (at which point the imaginal chunk for the iteration will
   ; be back and have its value)
   (p addition-start-pair
     =imaginal>
       isa add-pair
       one1 =one1
       one2 =one2
       ten1 =ten1
       ten2 =ten2
       one-ans nil
     ?retrieval>
       state free
    =goal>
      isa task
      step start-add
     !safe-eval! (not (issimpleaddition (combine =ten1 =one1) (combine =ten2 =one2)))
   ==>
      =imaginal> =imaginal
     +goal>
       step one-ans
     +retrieval>
       isa addition-fact
       addend1 =one1
       addend2 =one2
   )
   
   (p addition-simple
     =imaginal>
       isa add-pair
       one1 =one1
       one2 =one2
       ten1 =ten1
       ten2 =ten2
       one-ans nil
     ?imaginal>
       state free
    =goal>
      isa task
      step start-add
     !safe-eval! (issimpleaddition (combine =ten1 =one1) (combine =ten2 =one2))
   ==>
    !safe-bind! =ans (add (combine =ten1 =one1) (combine =ten2 =one2))
    !safe-bind! =ansOnes (ones =ans)
    !safe-bind! =ansTens (tens =ans)
     +imaginal>
       one-ans =ansOnes
       ten-ans =ansTens
       combined-sum =ans
    +goal>
      step add-done
   )
   
   
   (p add-ones-no-carry
     =imaginal>
       isa add-pair
       one1 =one1
       one2 =one2
       ten1 =ten1
       ten2 =ten2
    =goal>
      isa task
      step one-ans
     =retrieval>
       isa addition-fact
       sum =sum
     ?imaginal>
       state free
     !safe-eval! (and (< (chunk-to-number =sum) 10) (>= (chunk-to-number =sum) 0))
   ==>
     +imaginal>
       one-ans =sum
       carry nil 
    +goal>
      step ten-ans-retrieve
   )


   (p add-ones-and-carry
     =imaginal>
       isa add-pair
       one1 =one1
       one2 =one2
       ten1 =ten1
       ten2 =ten2
     =retrieval>
       isa addition-fact
       sum =sum
     ?imaginal>
       state free
    =goal>
      isa task
      step one-ans
     !safe-eval! (>= (chunk-to-number =sum) 10)
   ==>
     !safe-bind! =remainder (tostring (- (chunk-to-number =sum) 10))
     +imaginal>
       one-ans =remainder
       carry n1
    +goal>
      step ten-ans-retrieve
   )



   ; borrow mediates through declarative memory,
   ; adding 10 to one1 and getting the fact for the subtraction again
   ; alternatively, it could add 10 to the (negative) sum currently in the
   ; retrieval buffer and use that as the one-ans
   ;
   ; however, adding 10 to -1 .. -9 is harder than adding 10 to 0..9, since its
   ; not just writing a 1 in the tens spot
 (p add-ones-borrow
   =imaginal>
     isa add-pair
     one1 =one1
     one2 =one2
     ten1 =ten1
     ten2 =ten2
   =retrieval>
     isa addition-fact
     sum =sum
  ?imaginal>
       state free
    =goal>
      isa task
      step one-ans
   !safe-eval! (< (chunk-to-number =sum) 0)
 ==>
   !safe-bind! =borrowed (tostring (+ 10 (chunk-to-number =one1)))
   +imaginal>
     one1 =borrowed
     carry n-1
  +goal>
    step one-ans-borrow
 )

 (p add-ones-borrow-retrieve
   =imaginal>
     isa add-pair
     one1 =one1
     one2 =one2
  =goal>
      isa task
    step one-ans-borrow
     ?imaginal>
       state free
   ==>
   +retrieval>
     isa addition-fact
     addend1 =one1
     addend2 =one2
    =imaginal> =imaginal
  +goal>
    step one-ans-borrow2
 )


 (p add-ones-finish-borrow
   =imaginal>
     isa add-pair
     one1 =one1
     one2 =one2
     ten1 =ten1
     ten2 =ten2
   =goal>
      isa task
    step one-ans-borrow2
     =retrieval>
     isa addition-fact
     sum =sum
  ?imaginal>
       state free
   !safe-eval! (< (chunk-to-number =sum) 10) 
   ; really just a check for a model error, this should always retrieve and be
   ; 0-9
 ==>
   +imaginal>
     one-ans =sum
   +goal>
    step ten-ans-retrieve
 )
 
   (p add-tens-retrieval
     =imaginal>
       isa add-pair
       ten1 =ten1
       ten2 =ten2
    =goal>
      isa task
      step ten-ans-retrieve
       !safe-eval! (not (and (eq =ten1 'n0) (eq =ten2 'n0)))
   ==>
     +retrieval>
       isa addition-fact
       addend1 =ten1 
       addend2 =ten2 
     =imaginal> =imaginal
     +goal>
      step ten-ans
   )


 (p add-tens-carry
   =imaginal>
     isa add-pair
     ten1 =ten1
     ten2 =ten2
    carry =carry
   =goal>
      isa task
    step ten-ans
    =retrieval>
     isa addition-fact
     sum =sum
  ?imaginal>
       state free
 ==>
   +imaginal>
     carry nil
   +retrieval>
     isa addition-fact
     addend1 =carry
     addend2 =sum
 )


   
   (p add-tens-zeros-done
     =imaginal>
       isa add-pair
       one-ans =ones
       ten1 n0
       ten2 n0
       carry nil
     ?imaginal>
       state free
    =goal>
      isa task
      step ten-ans-retrieve
   ==>
     !safe-bind! =comb (combine 'n0 =ones)
     +imaginal>
       ten-ans n0
       combined-sum =comb
    +goal>
      step add-done
   )
   
   (p add-tens-zeros-done-carry1
     =imaginal>
       isa add-pair
       ten1 n0
       ten2 n0
       one-ans =ones
       carry n1
     ?imaginal>
       state free
    =goal>
      isa task
      step ten-ans-retrieve
   ==>
     !safe-bind! =comb (combine 'n1 =ones)
     +imaginal>
       ten-ans n1
       combined-sum =comb
    +goal>
      step add-done
   )
   
   (p add-tens-zeros-done-carry-1
     =imaginal>
       isa add-pair
       one-ans =ones
       ten1 n0
       ten2 n0
       carry n-1
    =goal>
      isa task
      step ten-ans-retrieve
     ?imaginal>
       state free
     ==>
     !safe-bind! =comb (combine n0 =ones)
     +imaginal>
       ten-ans n-1
       combined-sum =comb
    +goal>
      step add-done
   )

   (p add-tens-done
     =goal>
       isa task
       current-problem =prob
     =imaginal>
       isa add-pair
       one-ans =ones
       carry nil
    =goal>
      isa task
      step ten-ans
     =retrieval>
       isa addition-fact
       sum =sum
     ?imaginal>
       state free
   ==>
     !safe-bind! =comb (combine =sum =ones)
     +imaginal>
       ten-ans =sum
       combined-sum =comb
    +goal>
      step add-done
   )


    (goal-focus goal)
  )

