function [b prediction residuals factors regressors] = regressBlock(bold, indices, events,conditions)
% gets nBetas betas for the region passed in

% problemTypes = {'NegHt','Mirror','NegBase','LBUH','LBUV','DoubleX','UnkHeight','UnkBase','FracHeight','Regular'};

combinedResponses = 0;
use8s = 1;
fourRegressors = 0;
collapseCorrectness = 0;


useDetailedEvents = 1;

nSubparts = 4;


indices(:,5) = indices(:,5) - min(indices(:,5)) + 1;

nBetas = 4*nSubparts*2 + nSubparts; % nTypes * [before,response,after] * [correct,incorrect] + timeout * [b,r,a]
incorrectStartCol = 4*nSubparts+1;

types = indices(:,2);
outcomes = indices(:,4);
nscans = size(bold,1);
factors =zeros(nscans,nBetas);
count = 0;
lastEvent = 0;
for i = 1:nscans
  if events(i,2) > 0
    lastEvent = i;
  end

  if types(i) > 0
      count = count + 1;
  else
      if count > 1
        % type is asserted from onset to feedback end
        % this is the first scan after type goes to 0
        
        problemStart = i - count - 2;
        problemEnd = i + 11;

        % build factors to be set starting 2 scans before onset
        factors1 = zeros(count+14,nSubparts); % add 2 scans before and 3 after

        eventScan = lastEvent - problemStart + 1; % should be count or count + 1
        % eventScan = count; % TEMP
        
        isTO = 0;
        if eventScan ~= count && eventScan ~= count + 1
          isTO = 1;
          eventScan = count; % fix to allow fake "response" factor to match CABN analysis
        end

        if isTO == 0 && useDetailedEvents
          eventStart = lastEvent;
          eventEnd = lastEvent;
          while events(eventStart,2) > 0
            eventStart = eventStart - 1;
          end
          
          eventStart = eventStart + 1;
          % eventStart is now the (absolutely numbered) scan of the first kp
          
          if eventStart < problemStart
            halt = here;
          end
          relEventStart = eventStart - problemStart + 1;
          relEventEnd = eventEnd - problemStart + 1;
          factors1(1,1)=.5;
          factors1(2,1)=1;
          
          factors1(3:relEventStart-1,2) = 1; % pre period
          factors1(relEventStart,2) = events(eventStart,1); % pct of scan before first kp is in pre
          factors1(relEventStart:relEventEnd,3) = events(eventStart:eventEnd,2);
          
          lastEventScanWeight = 1-events(eventEnd,3);
          
          if fourRegressors
             % 5s feedback regressor
             % 0-2s is covered in relEventEnd
            factors1(relEventEnd,3) = 1 - lastEventScanWeight; 
            factors1(relEventEnd+1,3) = 1; % 2s, 1-3s left
            timeLeft = 5 - (2 + 2*(1-lastEventScanWeight));
            if (timeLeft <= 2)
              % 2s or less left
              lastFBScan = relEventEnd+2;
              lastFBWeight = timeLeft/2;
              factors1(lastFBScan,3) = lastFBWeight;
            else
              factors1(relEventEnd+2,3) = 1;
              lastFBScan = relEventEnd+3;
              lastFBWeight = (timeLeft-2)/2;
              factors1(lastFBScan,3) = lastFBWeight;
            end

            % 16s fixation/RD regressor
            factors1(lastFBScan,4) = 1-lastFBWeight; % 0-2s
            factors1(lastFBScan+1:lastFBScan+7,4) = 1; % 24s
            factors1(lastFBScan+8,4) = lastFBWeight; % rest of the 0-2s
          elseif use8s
          % third factor must always be 8s
          % so whatever time is left over in the last event scan, plus 3 scans
          % (6s), plus a last scan with 1-leftover
            factors1(relEventEnd,4) = 1 - lastEventScanWeight; 
            factors1(relEventEnd+1:relEventEnd+3,4) = 1; % post period
            factors1(relEventEnd+4,4) = lastEventScanWeight;
          else
             % 5s version:
             % 0-2s is covered in relEventEnd
            factors1(relEventEnd,3) = 1 - lastEventScanWeight; 
            factors1(relEventEnd+1,3) = 1; % 2s, 1-3s left
            timeLeft = 5 - (2 + 2*(1-lastEventScanWeight));
            if (timeLeft <= 2)
              % 2s or less left
              factors1(relEventEnd+2,3) = timeLeft/2;
            else
              factors1(relEventEnd+2,3) = 1;
              factors1(relEventEnd+3,3) = (timeLeft - 2)/2;
            end
          end
        else
          % timeout or no details
          factors1(1,1)=.5;
          factors1(2,1)=1;
          factors1(3:eventScan-1,2) = 1; % pre period
          %factors1(eventScan-1,1) = .5; % pre period
          %factors1(eventScan-1,2) = .5; % pre period
          factors1(eventScan,3) = .5; % 1s of response
          factors1(eventScan,4) = .5; 
          factors1(eventScan+1:eventScan+2,4) = 1; % post period
          if fourRegressors
            factors1(eventScan+3:eventScan+11,4) = 1; % 16s fix/rd
          elseif use8s
            % overwrite 5s regressor with 8s
            factors1(eventScan+1:eventScan+3,4) = 1; % post period
            factors1(eventScan+4,4) = .5;
          end
        end
        if isTO
          typeIdx = 5;
          offset = (typeIdx-1)*nSubparts+incorrectStartCol;
          factors(problemStart:problemEnd,offset:offset+nSubparts-1)=factors1;
        elseif outcomes(i-1) == 1 || collapseCorrectness
              if types(i-1)<3
                typeIdx = 1; % regular
                offset = (typeIdx-1)*nSubparts+1;
                factors(problemStart:problemEnd,offset:offset+nSubparts-1)=factors1;
              else
                typeIdx = round(10*(indices(i-1,2)-3));
                typeIdx = conditions(typeIdx);
                offset = (typeIdx-1)*nSubparts+1;
                factors(problemStart:problemEnd,offset:offset+nSubparts-1)=factors1;
              end
          else
              if types(i-1)<3
                typeIdx = 1; % regular
                offset = (typeIdx-1)*nSubparts + incorrectStartCol;
                factors(problemStart:problemEnd,offset:offset+nSubparts-1)=factors1;
              else
                typeIdx = round(10*(indices(i-1,2)-3));
                typeIdx = conditions(typeIdx);
                offset = (typeIdx-1)*nSubparts + incorrectStartCol;
                factors(problemStart:problemEnd,offset:offset+nSubparts-1)=factors1;
              end
        end
          %[i-1, typeIdx,offset, indices(i-1,:)]
      end
      
      count = 0;
  end
end
factors=reshape(factors,nscans,4,9);
factors=cat(2,reshape(factors(:,[2,4],:),nscans,18),sum(factors(:,1,:),3),sum(factors(:,3,:),3));
g=zeros(15,1);
for i = 1:15
    g(i)=gamcdf(i*2,7,0.75)-gamcdf(i*2-2,7,0.75);
end
regressors = zeros(nscans+14,15);
for i = 1:20
    regressors(:,i)=conv(factors(:,i),g);
end

if combinedResponses
  % combine all response regressors into two: the first correct response
  % regressor and the first incorrect response regressor
  % (i.e., combining regular and all exception types)
  % zero out the other response cols

  % after regression, copy the reponse beta to the merged columns so this is
  % transparent to calling code

  correctResponseCol = 2;
  incorrectResponseCol = incorrectStartCol + 1;

  correctResponseMergeColumns = correctResponseCol+3:3:incorrectStartCol;
  incorrectResponseMergeColumns = incorrectResponseCol+3:3:(size(regressors,2)-3); % don't include timeout!

  for col = correctResponseMergeColumns
    regressors(:,correctResponseCol) = regressors(:,correctResponseCol) + regressors(:,col);
    regressors(:,col) = 0;
  end
  for col = incorrectResponseMergeColumns
    regressors(:,incorrectResponseCol) = regressors(:,incorrectResponseCol) + regressors(:,col);
    regressors(:,col) = 0;
  end
end

regressors=cat(2,regressors(1:nscans,:),blockfactors(indices(:,5)));

% need to remove empty columns from the matrix so regress doesn't complain
nonzero = [];
isZero = [];
for i = 1:size(regressors, 2)
  if find(regressors(:,i))
      nonzero  = [nonzero i];
  else
    isZero = [isZero i];
  end
end

[b(nonzero,1), xx, residuals] = regress(bold,regressors(1:nscans,nonzero));

residuals = sum(abs(residuals));

prediction = regressors(1:nscans,:)*b;

b(isZero,1) = NaN;

if combinedResponses
  % copy the response betas to all the types
  b(correctResponseMergeColumns) = b(correctResponseCol);
  b(incorrectResponseMergeColumns) = b(incorrectResponseCol);
end

if fourRegressors
  % eliminate the fix/rd regressor so the 3/4 difference is invisible to caller
  b(4:4:nBetas) = [];
end
b=b(1:20)'/mean(bold); 
b(isnan(b))=0;