function factors  = regressFactors1(indices, events)
% problemTypes = {'NegHt','Mirror','NegBase','LBUH','LBUV','DoubleX','UnkHeight','UnkBase','FracHeight','Regular'};

use8s = 1;
fourRegressors = 0;
collapseCorrectness = 0;


useDetailedEvents = 1;

nSubparts = 4;
if fourRegressors
  nSubparts = 4;
end

indices(:,5) = indices(:,5) - min(indices(:,5)) + 1;

types = indices(:,2);
outcomes = indices(:,4);
nscans = size(events,1);
factors =zeros(nscans,20);
count = 0;
lastEvent = 0;
for i = 1:nscans
  if events(i,2) > 0
    lastEvent = i;
  end

  if types(i) > 0
      count = count + 1;
  else
      if count > 1
        % type is asserted from onset to feedback end
        % this is the first scan after type goes to 0
        
        problemStart = i - count - 2;
        problemEnd = i + 11;

        % build factors to be set starting 2 scans before onset
        factors1 = zeros(count+14,nSubparts); % add 2 scans before and 3 after

        eventScan = lastEvent - problemStart + 1; % should be count or count + 1
        % eventScan = count; % TEMP
        
        isTO = 0;
        if eventScan ~= count && eventScan ~= count + 1
          isTO = 1;
          eventScan = count; % fix to allow fake "response" factor to match CABN analysis
        end

        if isTO == 0 && useDetailedEvents
          eventStart = lastEvent;
          eventEnd = lastEvent;
          while events(eventStart,2) > 0
            eventStart = eventStart - 1;
          end
          
          eventStart = eventStart + 1;
          % eventStart is now the (absolutely numbered) scan of the first kp
          
          if eventStart < problemStart
            halt = here;
          end
          relEventStart = eventStart - problemStart + 1;
          relEventEnd = eventEnd - problemStart + 1;
          factors1(1,1) = .5;
          factors1(2,1) = 1;
          factors1(3:relEventStart-1,2) = 1; % pre period
          factors1(relEventStart,2) = events(eventStart,1); % pct of scan before first kp is in pre
          factors1(relEventStart:relEventEnd,3) = events(eventStart:eventEnd,2);
          
          lastEventScanWeight = 1-events(eventEnd,3);
          
          if fourRegressors
             % 5s feedback regressor
             % 0-2s is covered in relEventEnd
            factors1(relEventEnd,4) = 1 - lastEventScanWeight; 
            factors1(relEventEnd+1,4) = 1; % 2s, 1-3s left
            timeLeft = 5 - (2 + 2*(1-lastEventScanWeight));
            if (timeLeft <= 2)
              % 2s or less left
              lastFBScan = relEventEnd+2;
              lastFBWeight = timeLeft/2;
              factors1(lastFBScan,4) = lastFBWeight;
            else
              factors1(relEventEnd+2,4) = 1;
              lastFBScan = relEventEnd+3;
              lastFBWeight = (timeLeft-2)/2;
              factors1(lastFBScan,4) = lastFBWeight;
            end

            % 16s fixation/RD regressor
            factors1(lastFBScan,4) = 1-lastFBWeight; % 0-2s
            factors1(lastFBScan+1:lastFBScan+7,4) = 1; % 24s
            factors1(lastFBScan+8,4) = lastFBWeight; % rest of the 0-2s
          elseif use8s
          % third factor must always be 8s
          % so whatever time is left over in the last event scan, plus 3 scans
          % (6s), plus a last scan with 1-leftover
            factors1(relEventEnd,4) = 1 - lastEventScanWeight; 
            factors1(relEventEnd+1:relEventEnd+3,4) = 1; % post period
            factors1(relEventEnd+4,4) = lastEventScanWeight;
          else
             % 5s version:
             % 0-2s is covered in relEventEnd
            factors1(relEventEnd,4) = 1 - lastEventScanWeight; 
            factors1(relEventEnd+1,4) = 1; % 2s, 1-3s left
            timeLeft = 5 - (2 + 2*(1-lastEventScanWeight));
            if (timeLeft <= 2)
              % 2s or less left
              factors1(relEventEnd+2,4) = timeLeft/2;
            else
              factors1(relEventEnd+2,4) = 1;
              factors1(relEventEnd+3,4) = (timeLeft - 2)/2;
            end
          end
        else
          % timeout or no details
          factors1(3:eventScan-1,2) = 1; % pre period
          %factors1(eventScan-1,1) = .5; % pre period
          %factors1(eventScan-1,2) = .5; % pre period
          factors1(eventScan,3) = .5; % 1s of response
          factors1(eventScan,4) = .5; 
          factors1(eventScan+1:eventScan+2,4) = 1; % post period
          if fourRegressors
            factors1(eventScan+3:eventScan+11,4) = 1; % 16s fix/rd
          elseif use8s
            % overwrite 5s regressor with 8s
            factors1(eventScan+1:eventScan+3,4) = 1; % post period
            factors1(eventScan+4,4) = .5;
          end
        end
        if isTO
          factors1(end-10:end-4,4)=1;
          factors(problemStart:problemEnd,17:20)=factors1;
        elseif outcomes(i-1) == 1 || collapseCorrectness
              if types(i-1)<3
                factors(problemStart:problemEnd,1:4)=factors1;
              else
                factors(problemStart:problemEnd,5:8)=factors1;
              end
          else
              if types(i-1)<3
                factors(problemStart:problemEnd,9:12)=factors1;
              else
                factors(problemStart:problemEnd,13:16)=factors1;
              end
        end
          %[i-1, typeIdx,offset, indices(i-1,:)]
      end
      count = 0;
  end
end
factors=reshape(factors,nscans,4,5);
factors=cat(2,reshape(factors(:,[2,4],:),nscans,10),sum(factors(:,1,[1,2,4]),3),sum(factors(:,3,[1,2,4]),3),sum(factors(:,1,[3,5]),3),sum(factors(:,3,[3,5]),3));
factors=factors(:,[1,2,3,4,7,8,11,12,5,6,9,10,13,14]);
factors(:,9)=sum(factors(:,9:14),2);
factors(:,10:14)=[];
realstart = find(types>0);
factors(1:realstart-3,9)=1;
